/////////////////////////////////////////////////////////////
//Beispiel Kapitel Prozeduren: Unbeabsichtigte Nebenwirkungen
/////////////////////////////////////////////////////////////
float ang1 = 0;
float ang2 = 0; 

void setup() {
  size(600, 600);
}


void draw() {
  background(255);
  ellipseTransformieren(80, 80, ang1, color(200, 0, 0, 100));
  ellipseTransformieren(200,200,ang2, color(100,100, 250, 100));
  ang1 += 0.01;
  ang2 += 0.03;
}

void ellipseTransformieren(int x1, int x2, float angle, color farbe) { 

  // Grafikzustand speichern
  // pushMatrix();
  pfeil(0,0,x1,x2);
  translate(x1, x2);
  rotate(angle);
  pfeil(0,0,100,0);
  pfeil(0,0,0,100);
  fill(farbe);
  ellipse(0, 0, 80, 40);
  // Grafikzustand wiederherstellen
  // popMatrix();
}

// male eine Pfeil
void pfeil(int x0, int y0, int x1, int y1) {
  float ang = atan2(y1-y0,x1-x0);
  fill(0);
  line(x0,y0,x1,y1);
  triangle(x1,y1,
    x1-cos(ang+radians(15))*20,y1-sin(ang+radians(15))*20,
    x1-cos(ang-radians(15))*20,y1-sin(ang-radians(15))*20
  );
}